/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#ifndef GTKMM_PARTY_SETTINGS_HEADER
#define GTKMM_PARTY_SETTINGS_HEADER

#include "base.h"
#include <gtkmm/dialog.h>
namespace Gtk {
  class Notebook;
  class StockButton;
  class Label;
  class SpinButton;
  class CheckButton;
  class RadioButton;
} // namespace Gtk

class Setting;
class Player;

namespace UI_GTKMM_NS {
  class Players;
  class Rules;

  /**
   **
   ** @brief	the party settings dialog
   **
   ** @author	Diether Knof
   **
   **/
  class PartySettings : public Base, public Gtk::Dialog {
    public:
      PartySettings(Base* const parent);

      ~PartySettings();

      void create_backup();
      void reset();

      void get();
      void on_show();

      void load_bug_report();

      void show_rules();

      void sensitivity_update();
      void seed_value_sensitivity_update();

      void update();

      void player_update(Player const& player);
      void name_update(Player const& player);
    private:
      void name_update_local(Player const& player);
    public:

    private:
      void init();

    public:
      Players* players;
      Rules* rules;

    private:
      unsigned seed_bak;
      unsigned startplayer_first_bak;

      Gtk::Notebook* notebook;

    private:
      Gtk::StockButton* reset_button;
      Gtk::StockButton* load_bug_report_button;
      Gtk::StockButton* start_party_button;
      Gtk::StockButton* close_button;

      Gtk::SpinButton* seed_value;
      Gtk::CheckButton* seed_random;

      vector<Gtk::RadioButton*> startplayer;
      Gtk::RadioButton* startplayer_random;

    private: // unused
      PartySettings();
      PartySettings(PartySettings const& main_window);
      PartySettings& operator=(PartySettings const& main_window);
  }; // class PartySettings : public Base, public Gtk::Dialog

} // namespace UI_GTKMM_NS

#endif // #ifdef GTKMM_PARTY_SETTINGS_HEADER

#endif // #ifdef USE_UI_GTKMM
